hdu 1496 hash+暴力

来源:互联网 发布:双向视觉优化训练系统 编辑:程序博客网 时间:2024/04/30 02:04

http://acm.hdu.edu.cn/showproblem.php?pid=1496

Problem Description
Consider equations having the following form: 

a*x1^2+b*x2^2+c*x3^2+d*x4^2=0
a, b, c, d are integers from the interval [-50,50] and any of them cannot be 0.

It is consider a solution a system ( x1,x2,x3,x4 ) that verifies the equation, xi is an integer from [-100,100] and xi != 0, any i ∈{1,2,3,4}.

Determine how many solutions satisfy the given equation.
 

Input
The input consists of several test cases. Each test case consists of a single line containing the 4 coefficients a, b, c, d, separated by one or more blanks.
End of file.
 

Output
For each test case, output a single line containing the number of the solutions.
 

Sample Input
1 2 3 -41 1 1 1
 

Sample Output
390880
这道题可以用枚举二分来,但是哈希更加简单

我们把每个数都加上1000000就能保证a*i*i, b*j*j, -c*i*i,-d*j*j是正整数了,因此就可以用数组来表示了

#include <stdio.h>#include <string.h>#include <iostream>#include <algorithm>using namespace std;int hash[1000000*2+7];int a,b,c,d;int main(){    while(~scanf("%d%d%d%d",&a,&b,&c,&d))    {        memset(hash,0,sizeof(hash));        for(int i=1;i<=100;i++)        {            for(int j=1;j<=100;j++)            {                hash[i*i*a+j*j*b+1000000]++;            }        }        int sum=0;        for(int i=1;i<=100;i++)        {            for(int j=1;j<=100;j++)            {                sum+=hash[-i*i*c-j*j*d+1000000];            }        }        printf("%d\n",sum*16);    }    return 0;}


0 0
原创粉丝点击